Package weka.attributeSelection

# Class CorrelationAttributeEval

java.lang.Object
weka.attributeSelection.ASEvaluation
weka.attributeSelection.CorrelationAttributeEval

All Implemented Interfaces:
  `Serializable`, `AttributeEvaluator`, `CapabilitiesHandler`, `CapabilitiesIgnorer`, `CommandlineRunnable`, `OptionHandler`, `RevisionHandler`

public class CorrelationAttributeEval extends ASEvaluation implements AttributeEvaluator, OptionHandler
CorrelationAttributeEval :
Evaluates the worth of an attribute by measuring the correlation (Pearson's) between it and the class.
Nominal attributes are considered on a value by value basis by treating each value as an indicator. An overall correlation for a nominal attribute is arrived at via a weighted average.

Valid options are:

     -D
      Output detailed info for nominal attributes

Version:
  $Revision: 15520 $
Author:
  Mark Hall (mhall{[at]}pentaho{[dot]}com)
See Also:
  - Serialized Form

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CorrelationAttributeEval()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `buildEvaluator(Instances data)`
  Initializes an information gain attribute evaluator.
  `double`
  `evaluateAttribute(int attribute)`
  Evaluates an individual attribute by measuring the correlation (Pearson's) between it and the class.
  `Capabilities`
  `getCapabilities()`
  Returns the capabilities of this evaluator.
  `String[]`
  `getOptions()`
  Gets the current settings of WrapperSubsetEval.
  `boolean`
  `getOutputDetailedInfo()`
  Get whether to output per-value correlation for nominal attributes
  `String`
  `getRevision()`
  Returns the revision string.
  `String`
  `globalInfo()`
  Returns a string describing this attribute evaluator
  `Enumeration<Option>`
  `listOptions()`
  Returns an enumeration describing the available options.
  `static void`
  `main(String[] args)`
  Main method for testing this class.
  `String`
  `outputDetailedInfoTipText()`
  Returns the tip text for this property
  `void`
  `setOptions(String[] options)`
  Parses a given list of options.
  `void`
  `setOutputDetailedInfo(boolean d)`
  Set whether to output per-value correlation for nominal attributes
  `String`
  `toString()`
  Describe the attribute evaluator

  ### Methods inherited from class weka.attributeSelection.ASEvaluation

  `clean, doNotCheckCapabilitiesTipText, forName, getDoNotCheckCapabilities, makeCopies, postExecution, postProcess, preExecution, run, runEvaluator, setDoNotCheckCapabilities`

  ### Methods inherited from class java.lang.Object

  `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### CorrelationAttributeEval

    public CorrelationAttributeEval()

- ## Method Details

  - ### globalInfo

    public String globalInfo()
    Returns a string describing this attribute evaluator
    Returns:
      a description of the evaluator suitable for displaying in the explorer/experimenter gui

  - ### getCapabilities

    public Capabilities getCapabilities()
    Returns the capabilities of this evaluator.
    Specified by:
      `getCapabilities` in interface `CapabilitiesHandler`
    Overrides:
      `getCapabilities` in class `ASEvaluation`
    Returns:
      the capabilities of this evaluator
    See Also:
      - `Capabilities`

  - ### listOptions

    public Enumeration<Option> listOptions()
    Returns an enumeration describing the available options.
    Specified by:
      `listOptions` in interface `OptionHandler`
    Overrides:
      `listOptions` in class `ASEvaluation`
    Returns:
      an enumeration of all the available options.

  - ### setOptions

    public void setOptions(String[] options) throws Exception
    Parses a given list of options.

    Valid options are:

         -D
          Output detailed info for nominal attributes

    Specified by:
      `setOptions` in interface `OptionHandler`
    Overrides:
      `setOptions` in class `ASEvaluation`
    Parameters:
      `options` - the list of options as an array of strings
    Throws:
      `Exception` - if an option is not supported

  - ### getOptions

    public String[] getOptions()
    Gets the current settings of WrapperSubsetEval.
    Specified by:
      `getOptions` in interface `OptionHandler`
    Overrides:
      `getOptions` in class `ASEvaluation`
    Returns:
      an array of strings suitable for passing to setOptions()

  - ### outputDetailedInfoTipText

    public String outputDetailedInfoTipText()
    Returns the tip text for this property
    Returns:
      tip text for this property suitable for displaying in the explorer/experimenter gui

  - ### setOutputDetailedInfo

    public void setOutputDetailedInfo(boolean d)
    Set whether to output per-value correlation for nominal attributes
    Parameters:
      `d` - true if detailed (per-value) correlation is to be output for nominal attributes

  - ### getOutputDetailedInfo

    public boolean getOutputDetailedInfo()
    Get whether to output per-value correlation for nominal attributes
    Returns:
      true if detailed (per-value) correlation is to be output for nominal attributes

  - ### evaluateAttribute

    public double evaluateAttribute(int attribute) throws Exception
    Evaluates an individual attribute by measuring the correlation (Pearson's) between it and the class. Nominal attributes are considered on a value by value basis by treating each value as an indicator. An overall correlation for a nominal attribute is arrived at via a weighted average.
    Specified by:
      `evaluateAttribute` in interface `AttributeEvaluator`
    Parameters:
      `attribute` - the index of the attribute to be evaluated
    Returns:
      the correlation
    Throws:
      `Exception` - if the attribute could not be evaluated

  - ### toString

    public String toString()
    Describe the attribute evaluator
    Overrides:
      `toString` in class `Object`
    Returns:
      a description of the attribute evaluator as a String

  - ### buildEvaluator

    public void buildEvaluator(Instances data) throws Exception
    Initializes an information gain attribute evaluator. Replaces missing values with means/modes; Deletes instances with missing class values.
    Specified by:
      `buildEvaluator` in class `ASEvaluation`
    Parameters:
      `data` - set of instances serving as training data
    Throws:
      `Exception` - if the evaluator has not been generated successfully

  - ### getRevision

    public String getRevision()
    Returns the revision string.
    Specified by:
      `getRevision` in interface `RevisionHandler`
    Overrides:
      `getRevision` in class `ASEvaluation`
    Returns:
      the revision

  - ### main

    public static void main(String[] args)
    Main method for testing this class.
    Parameters:
      `args` - the options